<?php

namespace Verifone\Hosted\Controller\Standard;

class Redirect extends \Verifone\Hosted\Controller\Checkout
{
	/**
	 * @return \Magento\Framework\App\ResponseInterface|\Magento\Framework\Controller\Result\Json|\Magento\Framework\Controller\ResultInterface
	 * @throws \Magento\Framework\Exception\LocalizedException
	 */
    public function execute()
    {
        if (!$this->getRequest()->isAjax()) {
            $this->_cancelPayment();
            $this->_checkoutSession->restoreQuote();
            $this->getResponse()->setRedirect(
                $this->getCheckoutHelper()->getUrl('checkout')
            );
        }

        $quote = $this->getQuote();
        $email = $this->getRequest()->getParam('email');
        $paymentMethod = $this->getPaymentMethod();
        $quote->setCustomerEmail($email);
        $quote->reserveOrderId();
        if ($this->getCustomerSession()->isLoggedIn()) {
            $this->getCheckoutSession()->loadCustomerQuote();
            $quote->updateCustomerData($this->getQuote()->getCustomer());
            $quote->setCheckoutMethod(\Magento\Checkout\Model\Type\Onepage::METHOD_CUSTOMER);
        } else {
            $quote->setCheckoutMethod(\Magento\Checkout\Model\Type\Onepage::METHOD_GUEST);
        }

        $quote->setPaymentMethod($this->getPaymentMethod()->getCode());
        $quote->getPayment()->importData(['method' => $this->getPaymentMethod()->getCode()]);
        $this->_quoteRepository->save($quote);
	    $result = $this->getCheckoutHelper()->processPayment($paymentMethod, $quote);

	    $params = [];
        $params['method'] = 'GET';
        $params['url'] = $result['redirect'];
        return $this->_resultJsonFactory->create()->setData($params);
    }
}
