<?php


namespace Verifone\Hosted\Helper\Includes;
use Verifone\Hosted\Helper\Includes\MobileDetect;


class VerifoneHostedHelper {

	private $mobile_detect;

	/**
	 * VerifoneHostedHelper constructor.
	 */
	public function __construct() {
		$this->mobile_detect = new MobileDetect();
	}

	/**
	 * @return string
	 */
	public function getDeviceType()
	{
		$device_type = VERIFONE_ENV_TRANSACTION_MODE_COMPUTER_DEVICE;
		if($this->mobile_detect->isMobile()) {
			$device_type = VERIFONE_ENV_TRANSACTION_MODE_MOBILE_DEVICE;
		} elseif($this->mobile_detect->isTablet()) {
			$device_type = VERIFONE_ENV_TRANSACTION_MODE_TABLET_DEVICE;
		}

		return $device_type;
	}

	/**
	 * Used strictly for unit tests
	 *
	 * @param $class
	 */
	public function setMobileDetectClass($class)
	{
		$this->mobile_detect = $class;
	}
}
