<?php


namespace Verifone\Hosted\Helper\Includes;
use Verifone\Hosted\Helper\Includes\VerifoneApiEntity;


class VerifoneHostedRefund extends VerifoneApiEntity {

	private $quote;

	/**
	 * @var array
	 */
	protected $data;
	private $amount;
	private $reason;
	private $transactionId;

	public function __construct(
		$amount,
		$reason,
		$order,
		$transactionId
	) {
		$this->order   = $order;
		$this->amount   = $amount;
		$this->reason   = $reason;
		$this->transactionId = $transactionId;

		$this->buildData();
	}

	/**
	 * @throws \Exception
	 */
	private function buildData() {
		$date = new \DateTime('now');
		$this->data = [
			// the api requires that all params are string...for this endpoint
			// in the initial call the amount has to be an int
			// but it seems to work with a string too
			// talk about consistency...
			'amount' => "{$this->amount}",
			'reason' => $this->reason,
			'id' => "{$this->transactionId}",
			'referenceId' => "{$this->order->getQuoteId()}",
			'createdDateTime' => "{$date->format( 'Y-m-d\TH:i:s\Z' )}"
		];
	}

	/**
	 * @return array
	 */
	public function toArray()
	{
		return $this->data;
	}

	/**
	 * @return false|string
	 */
	public function toJson() {
		return json_encode($this->data);
	}

}

