<?php

namespace Verifone\Hosted\Helper\Interfaces;

/**
 * Interface ApiMapper
 */
interface ApiMapper {
	const VERIFONE_API_CUSTOMER_PATH = 'customer';
	const VERIFONE_API_CHECKOUT_PATH = 'checkout';
	const VERIFONE_PAYMENTS_REFUND_PATH = 'refund';
	const VERIFONE_API_PAYMENT_CONTRACTS = 'paymentContracts';

	const VERIFONE_PAYMENTS_API_VERSION = 'v1';
	const VERIFONE_API_VERSION = 'v1';

	/**
	 * @return string
	 */
	public function getToken();

	/**
	 * @return mixed
	 */
	public function getTokenRedirectUri();

	/**
	 * @param $transaction_id
	 *
	 * @return string
	 */
	public function getRefund( $transaction_id );

	/**
	 * @return string
	 */
	public function postCheckout();

	/**
	 * @param $checkout_id
	 *
	 * @return string
	 */
	public function getCheckout( $checkout_id );

	/**
	 * @return string
	 */
	public function postCustomer();

	/**
	 * @param $customer_id
	 *
	 * @return string
	 */
	public function getCustomer( $customer_id );

	/**
	 * @param $payment_contract_id
	 *
	 * @return mixed
	 */
	public function getPaymentContract($payment_contract_id);
}
