define(
    [
        'jquery',
        'Magento_Checkout/js/model/quote',
        'Magento_Customer/js/customer-data',
        'Magento_Checkout/js/model/url-builder',
        'mage/storage',
        'Magento_Checkout/js/model/error-processor',
        'Magento_Customer/js/model/customer',
        'Magento_Checkout/js/model/full-screen-loader'
    ],
    function ($, quote, customerData, urlBuilder, storage, errorProcessor, customer, fullScreenLoader) {
        'use strict';

        return function (messageContainer) {

            var serviceUrl,
                email;

            if (!customer.isLoggedIn()) {
                email = quote.guestEmail;
            } else {
                email = customer.customerData.email;
            }

            serviceUrl = window.checkoutConfig.payment.verifone_hosted.redirectUrl+'?email='+email;
            fullScreenLoader.startLoader();

            $.ajax({
                url: serviceUrl,
                type: 'post',
                context: this,
                data: {isAjax: 1},
                dataType: 'json',
                success: function (response) {
                    if ($.type(response) === 'object' && !$.isEmptyObject(response)) {
                        $('#verifone_payment_form').remove();
                        if(response.method == "GET"){
                            fullScreenLoader.stopLoader();
                            window.location.href = response.url;
                        }
                    } else {
                        fullScreenLoader.stopLoader();
                        alert($.mage.__('Sorry, something went wrong. Please try again.'));
                    }
                },
                error: function (response) {
                    fullScreenLoader.stopLoader();
                    alert($.mage.__('Sorry, something went wrong. Please try again.'));
                }
            });
        };
    }
);
